<?php

namespace Teknisa\SM\Controller;

use Teknisa\SM\Controller\SMCrud;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\SM\Util\Utilities;
use Teknisa\SM\Service\Sm00005000ParametrizacoesServicesService;
use Teknisa\SM\Service\FctContratoGridService;

class FctContratoGridController extends SMCrud {
    
    protected $dataSourceName = "fct_contrato_grid";
    protected $parametrogeral;
    protected $fctContratoGridService;
    
    public function __construct($crudService, $environment, Sm00005000ParametrizacoesServicesService $parametrogeral, FctContratoGridService $fctContratoGridService) {
        parent::__construct($crudService, $environment);
        $this->parametrogeral = $parametrogeral;
        $this->fctContratoGridService = $fctContratoGridService;
    }

    public function find(Request\Filter $request, Response $response) {
        try {
            $filterCriteria = $request->getFilterCriteria();
            
            $page     = $filterCriteria->getPage();
            $pageSize = $filterCriteria->getPageSize();
            $orderBy  = $filterCriteria->getOrderBy();
            
            $limit = $page * $pageSize;
            $offset = ($page - 1) * $pageSize;
            
            $conditions = $filterCriteria->getConditions();
            
            $idUtilizaOper = $this->parametrogeral->getIdUtilizaHierarquiaOper($this->environment->getNrorg());
            $usaHierarquia = $idUtilizaOper == "S";
            
            $cdoperador = $this->environment->getCdOperador();
            
            $dataset = $this->fctContratoGridService->find($usaHierarquia, $cdoperador, $conditions, $limit, $offset, $orderBy);
            $response->setDataSets(array(new DataSet($this->dataSourceName, $dataset)));
        }
        catch (\Exception $e) {
            $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
        }
    }
    
}

?>