<?php

namespace Teknisa\SM\Controller;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\SM\Service\Sm00057000ConfiguracaoRegionalService;

class Sm00057000ConfiguracaoRegionalController {

    protected $configRegionalService;

    public function __construct(Sm00057000ConfiguracaoRegionalService $configRegionalService) {
        $this->configRegionalService = $configRegionalService;
    }

    public function getIdiomaMoedaPadrao(Request\Row $request, Response $response) {
        try {
            $dataset = $this->configRegionalService->getIdiomaMoedaPadrao();
            $response->addDataSet(new DataSet("retorno", $dataset));
        }
        catch(\Exception $e){
            $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
        }
    }
}